import { type IType, PrimaryKeyProp, defineEntity, p } from '@mikro-orm/core';

export class ScsRole {
  [PrimaryKeyProp]?: 'Id';
  Id!: IType<number, bigint>;
  Code?: string;
  Name?: string;
  Description?: string;
  Nick?: string;
  Sort!: number;
  Enabled!: unknown;
  Revision!: number;
  CreatedBy?: IType<number, bigint>;
  CreatedTime!: Date;
  UpdatedBy?: IType<number, bigint>;
  UpdatedTime?: Date;
  IsDeleted!: unknown;
}

export const ScsRoleSchema = defineEntity({
  class: ScsRole,
  comment: '角色表',
  properties: {
    Id: p.bigint().primary().name('Id').columnType('bigint').unsigned(false).autoincrement(false).comment('主键Id'),
    Code: p.string().name('Code').length(20).nullable().comment('角色编码').index('idx_SCS_Role_01'),
    Name: p.string().name('Name').length(20).nullable().comment('角色名称').index('idx_SCS_Role_02'),
    Description: p.string().name('Description').nullable().comment('注释'),
    Nick: p.string().name('Nick').nullable().comment('角色别称'),
    Sort: p.integer().name('Sort').comment('排序'),
    Enabled: p.array().name('Enabled').comment('启用'),
    Revision: p.integer().name('Revision').comment('乐观锁'),
    CreatedBy: p.bigint().name('CreatedBy').columnType('bigint').nullable().comment('创建者用户Id'),
    CreatedTime: p.datetime().name('CreatedTime').length(3).comment('创建时间'),
    UpdatedBy: p.bigint().name('UpdatedBy').columnType('bigint').nullable().comment('修改者用户Id'),
    UpdatedTime: p.datetime().name('UpdatedTime').length(3).nullable().comment('修改时间'),
    IsDeleted: p.array().name('IsDeleted').comment('是否删除'),
  },
});
